# arithmetic_circuits.py
# Approximation of arithmetic circuits in alternative representations, BIN, 29.4.2022
# Author: Matěj Kudera, xkuder04, VUT FIT
# Truth tables for aritmetic circuits

circuits = {
    ####### Adders ######
    # 2 bit adder
    # A1,A0,B1,B0|C,S1,S0
    "adder_2b" : {'0000': '000', '0001': '001', '0010': '010', '0011': '011', '0100': '001', '0101': '010', '0110': '011', '0111': '100', '1000': '010', '1001': '011', '1010': '100', '1011': '101', '1100': '011', '1101': '100', '1110': '101', '1111': '110'},

    # 2 bit adder with input carry
    # CIN,A1,A0,B1,B0|COUT,S1,S0
    "adder_carry_2b" : {'00000': '000', '00001': '001', '00010': '010', '00011': '011', '00100': '001', '00101': '010', '00110': '011', '00111': '100', '01000': '010', '01001': '011', '01010': '100', '01011': '101', '01100': '011', '01101': '100', '01110': '101', '01111': '110', '10000': '001', '10001': '010', '10010': '011', '10011': '100', '10100': '010', '10101': '011', '10110': '100', '10111': '101', '11000': '011', '11001': '100', '11010': '101', '11011': '110', '11100': '100', '11101': '101', '11110': '110', '11111': '111'},

    # 2 bit adder and subtractor
    # CIN,A0,B0,A1,B1|S0,S1,COUT
    "adder_subtractor_2b" : {
        "00000": "000", 
        "00001": "010", 
        "00010": "010",
        "00011": "001",
        "00100": "100",
        "00101": "110",
        "00110": "110",
        "00111": "101",
        "01000": "100",
        "01001": "110",
        "01010": "110",
        "01011": "101",
        "01100": "010",
        "01101": "001",
        "01110": "001",
        "01111": "011",
        "10000": "001", # 10101
        "10001": "010", # 10100
        "10010": "011", # 10111
        "10011": "001", # 10110
        "10100": "110", # 10001
        "10101": "100", # 10000
        "10110": "101", # 10011
        "10111": "110", # 10010
        "11000": "101", # 11101
        "11001": "110", # 11100
        "11010": "111", # 11111
        "11011": "101", # 11110
        "11100": "001", # 11001
        "11101": "010", # 11000
        "11110": "011", # 11011
        "11111": "001" # 11010
    },

    # 4 bit adder
    # A3,A2,A1,A0,B3,B2,B1,B0|C,S3,S2,S1,S0
    "adder_4b" : {'00000000': '00000', '00000001': '00001', '00000010': '00010', '00000011': '00011', '00000100': '00100', '00000101': '00101', '00000110': '00110', '00000111': '00111', '00001000': '01000', '00001001': '01001', '00001010': '01010', '00001011': '01011', '00001100': '01100', '00001101': '01101', '00001110': '01110', '00001111': '01111', '00010000': '00001', '00010001': '00010', '00010010': '00011', '00010011': '00100', '00010100': '00101', '00010101': '00110', '00010110': '00111', '00010111': '01000', '00011000': '01001', '00011001': '01010', '00011010': '01011', '00011011': '01100', '00011100': '01101', '00011101': '01110', '00011110': '01111', '00011111': '10000', '00100000': '00010', '00100001': '00011', '00100010': '00100', '00100011': '00101', '00100100': '00110', '00100101': '00111', '00100110': '01000', '00100111': '01001', '00101000': '01010', '00101001': '01011', '00101010': '01100', '00101011': '01101', '00101100': '01110', '00101101': '01111', '00101110': '10000', '00101111': '10001', '00110000': '00011', '00110001': '00100', '00110010': '00101', '00110011': '00110', '00110100': '00111', '00110101': '01000', '00110110': '01001', '00110111': '01010', '00111000': '01011', '00111001': '01100', '00111010': '01101', '00111011': '01110', '00111100': '01111', '00111101': '10000', '00111110': '10001', '00111111': '10010', '01000000': '00100', '01000001': '00101', '01000010': '00110', '01000011': '00111', '01000100': '01000', '01000101': '01001', '01000110': '01010', '01000111': '01011', '01001000': '01100', '01001001': '01101', '01001010': '01110', '01001011': '01111', '01001100': '10000', '01001101': '10001', '01001110': '10010', '01001111': '10011', '01010000': '00101', '01010001': '00110', '01010010': '00111', '01010011': '01000', '01010100': '01001', '01010101': '01010', '01010110': '01011', '01010111': '01100', '01011000': '01101', '01011001': '01110', '01011010': '01111', '01011011': '10000', '01011100': '10001', '01011101': '10010', '01011110': '10011', '01011111': '10100', '01100000': '00110', '01100001': '00111', '01100010': '01000', '01100011': '01001', '01100100': '01010', '01100101': '01011', '01100110': '01100', '01100111': '01101', '01101000': '01110', '01101001': '01111', '01101010': '10000', '01101011': '10001', '01101100': '10010', '01101101': '10011', '01101110': '10100', '01101111': '10101', '01110000': '00111', '01110001': '01000', '01110010': '01001', '01110011': '01010', '01110100': '01011', '01110101': '01100', '01110110': '01101', '01110111': '01110', '01111000': '01111', '01111001': '10000', '01111010': '10001', '01111011': '10010', '01111100': '10011', '01111101': '10100', '01111110': '10101', '01111111': '10110', '10000000': '01000', '10000001': '01001', '10000010': '01010', '10000011': '01011', '10000100': '01100', '10000101': '01101', '10000110': '01110', '10000111': '01111', '10001000': '10000', '10001001': '10001', '10001010': '10010', '10001011': '10011', '10001100': '10100', '10001101': '10101', '10001110': '10110', '10001111': '10111', '10010000': '01001', '10010001': '01010', '10010010': '01011', '10010011': '01100', '10010100': '01101', '10010101': '01110', '10010110': '01111', '10010111': '10000', '10011000': '10001', '10011001': '10010', '10011010': '10011', '10011011': '10100', '10011100': '10101', '10011101': '10110', '10011110': '10111', '10011111': '11000', '10100000': '01010', '10100001': '01011', '10100010': '01100', '10100011': '01101', '10100100': '01110', '10100101': '01111', '10100110': '10000', '10100111': '10001', '10101000': '10010', '10101001': '10011', '10101010': '10100', '10101011': '10101', '10101100': '10110', '10101101': '10111', '10101110': '11000', '10101111': '11001', '10110000': '01011', '10110001': '01100', '10110010': '01101', '10110011': '01110', '10110100': '01111', '10110101': '10000', '10110110': '10001', '10110111': '10010', '10111000': '10011', '10111001': '10100', '10111010': '10101', '10111011': '10110', '10111100': '10111', '10111101': '11000', '10111110': '11001', '10111111': '11010', '11000000': '01100', '11000001': '01101', '11000010': '01110', '11000011': '01111', '11000100': '10000', '11000101': '10001', '11000110': '10010', '11000111': '10011', '11001000': '10100', '11001001': '10101', '11001010': '10110', '11001011': '10111', '11001100': '11000', '11001101': '11001', '11001110': '11010', '11001111': '11011', '11010000': '01101', '11010001': '01110', '11010010': '01111', '11010011': '10000', '11010100': '10001', '11010101': '10010', '11010110': '10011', '11010111': '10100', '11011000': '10101', '11011001': '10110', '11011010': '10111', '11011011': '11000', '11011100': '11001', '11011101': '11010', '11011110': '11011', '11011111': '11100', '11100000': '01110', '11100001': '01111', '11100010': '10000', '11100011': '10001', '11100100': '10010', '11100101': '10011', '11100110': '10100', '11100111': '10101', '11101000': '10110', '11101001': '10111', '11101010': '11000', '11101011': '11001', '11101100': '11010', '11101101': '11011', '11101110': '11100', '11101111': '11101', '11110000': '01111', '11110001': '10000', '11110010': '10001', '11110011': '10010', '11110100': '10011', '11110101': '10100', '11110110': '10101', '11110111': '10110', '11111000': '10111', '11111001': '11000', '11111010': '11001', '11111011': '11010', '11111100': '11011', '11111101': '11100', '11111110': '11101', '11111111': '11110'},

    # 4 bit adder with input carry
    # CIN,A3,A2,A1,A0,B3,B2,B1,B0|COUT,S3,S2,S1,S0
    "adder_carry_4b" : {'000000000': '00000', '000000001': '00001', '000000010': '00010', '000000011': '00011', '000000100': '00100', '000000101': '00101', '000000110': '00110', '000000111': '00111', '000001000': '01000', '000001001': '01001', '000001010': '01010', '000001011': '01011', '000001100': '01100', '000001101': '01101', '000001110': '01110', '000001111': '01111', '000010000': '00001', '000010001': '00010', '000010010': '00011', '000010011': '00100', '000010100': '00101', '000010101': '00110', '000010110': '00111', '000010111': '01000', '000011000': '01001', '000011001': '01010', '000011010': '01011', '000011011': '01100', '000011100': '01101', '000011101': '01110', '000011110': '01111', '000011111': '10000', '000100000': '00010', '000100001': '00011', '000100010': '00100', '000100011': '00101', '000100100': '00110', '000100101': '00111', '000100110': '01000', '000100111': '01001', '000101000': '01010', '000101001': '01011', '000101010': '01100', '000101011': '01101', '000101100': '01110', '000101101': '01111', '000101110': '10000', '000101111': '10001', '000110000': '00011', '000110001': '00100', '000110010': '00101', '000110011': '00110', '000110100': '00111', '000110101': '01000', '000110110': '01001', '000110111': '01010', '000111000': '01011', '000111001': '01100', '000111010': '01101', '000111011': '01110', '000111100': '01111', '000111101': '10000', '000111110': '10001', '000111111': '10010', '001000000': '00100', '001000001': '00101', '001000010': '00110', '001000011': '00111', '001000100': '01000', '001000101': '01001', '001000110': '01010', '001000111': '01011', '001001000': '01100', '001001001': '01101', '001001010': '01110', '001001011': '01111', '001001100': '10000', '001001101': '10001', '001001110': '10010', '001001111': '10011', '001010000': '00101', '001010001': '00110', '001010010': '00111', '001010011': '01000', '001010100': '01001', '001010101': '01010', '001010110': '01011', '001010111': '01100', '001011000': '01101', '001011001': '01110', '001011010': '01111', '001011011': '10000', '001011100': '10001', '001011101': '10010', '001011110': '10011', '001011111': '10100', '001100000': '00110', '001100001': '00111', '001100010': '01000', '001100011': '01001', '001100100': '01010', '001100101': '01011', '001100110': '01100', '001100111': '01101', '001101000': '01110', '001101001': '01111', '001101010': '10000', '001101011': '10001', '001101100': '10010', '001101101': '10011', '001101110': '10100', '001101111': '10101', '001110000': '00111', '001110001': '01000', '001110010': '01001', '001110011': '01010', '001110100': '01011', '001110101': '01100', '001110110': '01101', '001110111': '01110', '001111000': '01111', '001111001': '10000', '001111010': '10001', '001111011': '10010', '001111100': '10011', '001111101': '10100', '001111110': '10101', '001111111': '10110', '010000000': '01000', '010000001': '01001', '010000010': '01010', '010000011': '01011', '010000100': '01100', '010000101': '01101', '010000110': '01110', '010000111': '01111', '010001000': '10000', '010001001': '10001', '010001010': '10010', '010001011': '10011', '010001100': '10100', '010001101': '10101', '010001110': '10110', '010001111': '10111', '010010000': '01001', '010010001': '01010', '010010010': '01011', '010010011': '01100', '010010100': '01101', '010010101': '01110', '010010110': '01111', '010010111': '10000', '010011000': '10001', '010011001': '10010', '010011010': '10011', '010011011': '10100', '010011100': '10101', '010011101': '10110', '010011110': '10111', '010011111': '11000', '010100000': '01010', '010100001': '01011', '010100010': '01100', '010100011': '01101', '010100100': '01110', '010100101': '01111', '010100110': '10000', '010100111': '10001', '010101000': '10010', '010101001': '10011', '010101010': '10100', '010101011': '10101', '010101100': '10110', '010101101': '10111', '010101110': '11000', '010101111': '11001', '010110000': '01011', '010110001': '01100', '010110010': '01101', '010110011': '01110', '010110100': '01111', '010110101': '10000', '010110110': '10001', '010110111': '10010', '010111000': '10011', '010111001': '10100', '010111010': '10101', '010111011': '10110', '010111100': '10111', '010111101': '11000', '010111110': '11001', '010111111': '11010', '011000000': '01100', '011000001': '01101', '011000010': '01110', '011000011': '01111', '011000100': '10000', '011000101': '10001', '011000110': '10010', '011000111': '10011', '011001000': '10100', '011001001': '10101', '011001010': '10110', '011001011': '10111', '011001100': '11000', '011001101': '11001', '011001110': '11010', '011001111': '11011', '011010000': '01101', '011010001': '01110', '011010010': '01111', '011010011': '10000', '011010100': '10001', '011010101': '10010', '011010110': '10011', '011010111': '10100', '011011000': '10101', '011011001': '10110', '011011010': '10111', '011011011': '11000', '011011100': '11001', '011011101': '11010', '011011110': '11011', '011011111': '11100', '011100000': '01110', '011100001': '01111', '011100010': '10000', '011100011': '10001', '011100100': '10010', '011100101': '10011', '011100110': '10100', '011100111': '10101', '011101000': '10110', '011101001': '10111', '011101010': '11000', '011101011': '11001', '011101100': '11010', '011101101': '11011', '011101110': '11100', '011101111': '11101', '011110000': '01111', '011110001': '10000', '011110010': '10001', '011110011': '10010',
        '011110100': '10011', '011110101': '10100', '011110110': '10101', '011110111': '10110', '011111000': '10111', '011111001': '11000', '011111010': '11001', '011111011': '11010', '011111100': '11011', '011111101': '11100', '011111110': '11101', '011111111': '11110', '100000000': '00001', '100000001': '00010', '100000010': '00011', '100000011': '00100', '100000100': '00101', '100000101': '00110', '100000110': '00111', '100000111': '01000', '100001000': '01001', '100001001': '01010', '100001010': '01011', '100001011': '01100', '100001100': '01101', '100001101': '01110', '100001110': '01111', '100001111': '10000', '100010000': '00010', '100010001': '00011', '100010010': '00100', '100010011': '00101', '100010100': '00110', '100010101': '00111', '100010110': '01000', '100010111': '01001', '100011000': '01010', '100011001': '01011', '100011010': '01100', '100011011': '01101', '100011100': '01110', '100011101': '01111', '100011110': '10000', '100011111': '10001', '100100000': '00011', '100100001': '00100', '100100010': '00101', '100100011': '00110', '100100100': '00111', '100100101': '01000', '100100110': '01001', '100100111': '01010', '100101000': '01011', '100101001': '01100', '100101010': '01101', '100101011': '01110', '100101100': '01111', '100101101': '10000', '100101110': '10001', '100101111': '10010', '100110000': '00100', '100110001': '00101', '100110010': '00110', '100110011': '00111', '100110100': '01000', '100110101': '01001', '100110110': '01010', '100110111': '01011', '100111000': '01100', '100111001': '01101', '100111010': '01110', '100111011': '01111', '100111100': '10000', '100111101': '10001', '100111110': '10010', '100111111': '10011', '101000000': '00101', '101000001': '00110', '101000010': '00111', '101000011': '01000', '101000100': '01001', '101000101': '01010', '101000110': '01011', '101000111': '01100', '101001000': '01101', '101001001': '01110', '101001010': '01111', '101001011': '10000', '101001100': '10001', '101001101': '10010', '101001110': '10011', '101001111': '10100', '101010000': '00110', '101010001': '00111', '101010010': '01000', '101010011': '01001', '101010100': '01010', '101010101': '01011', '101010110': '01100', '101010111': '01101', '101011000': '01110', '101011001': '01111', '101011010': '10000', '101011011': '10001', '101011100': '10010', '101011101': '10011', '101011110': '10100', '101011111': '10101', '101100000': '00111', '101100001': '01000', '101100010': '01001', '101100011': '01010', '101100100': '01011', '101100101': '01100', '101100110': '01101', '101100111': '01110', '101101000': '01111', '101101001': '10000', '101101010': '10001', '101101011': '10010', '101101100': '10011', '101101101': '10100', '101101110': '10101', '101101111': '10110', '101110000': '01000', '101110001': '01001', '101110010': '01010', '101110011': '01011', '101110100': '01100', '101110101': '01101', '101110110': '01110', '101110111': '01111', '101111000': '10000', '101111001': '10001', '101111010': '10010', '101111011': '10011', '101111100': '10100', '101111101': '10101', '101111110': '10110', '101111111': '10111', '110000000': '01001', '110000001': '01010', '110000010': '01011', '110000011': '01100', '110000100': '01101', '110000101': '01110', '110000110': '01111', '110000111': '10000', '110001000': '10001', '110001001': '10010', '110001010': '10011', '110001011': '10100', '110001100': '10101', '110001101': '10110', '110001110': '10111', '110001111': '11000', '110010000': '01010', '110010001': '01011', '110010010': '01100', '110010011': '01101', '110010100': '01110', '110010101': '01111', '110010110': '10000', '110010111': '10001', '110011000': '10010', '110011001': '10011', '110011010': '10100', '110011011': '10101', '110011100': '10110', '110011101': '10111', '110011110': '11000', '110011111': '11001', '110100000': '01011', '110100001': '01100', '110100010': '01101', '110100011': '01110', '110100100': '01111', '110100101': '10000', '110100110': '10001', '110100111': '10010', '110101000': '10011', '110101001': '10100', '110101010': '10101', '110101011': '10110', '110101100': '10111', '110101101': '11000', '110101110': '11001', '110101111': '11010', '110110000': '01100', '110110001': '01101', '110110010': '01110', '110110011': '01111', '110110100': '10000', '110110101': '10001', '110110110': '10010', '110110111': '10011', '110111000': '10100', '110111001': '10101', '110111010': '10110', '110111011': '10111', '110111100': '11000', '110111101': '11001', '110111110': '11010', '110111111': '11011', '111000000': '01101', '111000001': '01110', '111000010': '01111', '111000011': '10000', '111000100': '10001', '111000101': '10010', '111000110': '10011', '111000111': '10100', '111001000': '10101', '111001001': '10110', '111001010': '10111', '111001011': '11000', '111001100': '11001', '111001101': '11010', '111001110': '11011', '111001111': '11100', '111010000': '01110', '111010001': '01111', '111010010': '10000', '111010011': '10001', '111010100': '10010', '111010101': '10011', '111010110': '10100', '111010111': '10101', '111011000': '10110', '111011001': '10111', '111011010': '11000', '111011011': '11001', '111011100': '11010', '111011101': '11011', '111011110': '11100', '111011111': '11101', '111100000': '01111', '111100001': '10000', '111100010': '10001', '111100011': '10010', '111100100': '10011', '111100101': '10100', '111100110': '10101', '111100111': '10110', '111101000': '10111', '111101001': '11000', '111101010': '11001', '111101011': '11010', '111101100': '11011', '111101101': '11100', '111101110': '11101', '111101111': '11110', '111110000': '10000', '111110001': '10001', '111110010': '10010', '111110011': '10011', '111110100': '10100', '111110101': '10101', '111110110': '10110', '111110111': '10111', '111111000': '11000', '111111001': '11001', '111111010': '11010', '111111011': '11011', '111111100': '11100', '111111101': '11101', '111111110': '11110', '111111111': '11111'},


    ####### Dividers #######
    # 2 bit divider
    # A/B
    # 0 division depends on architecture ¯\_(ツ)_/¯
    # A1,A0,B1,B0|Q1,Q0
    "divider_2b" : {'0000': '00', '0001': '00', '0010': '00', '0011': '00', '0100': '00', '0101': '01', '0110': '00', '0111': '00', '1000': '00', '1001': '10', '1010': '01', '1011': '00', '1100': '00', '1101': '11', '1110': '01', '1111': '01'},

    # 2 bit divider with remainder
    # A/B
    # 0 division depends on architecture ¯\_(ツ)_/¯
    # A1,A0,B1,B0|Q1,Q0,R1,R0
    "divider_with_remainder_2b" : {'0000': '0000', '0001': '0000', '0010': '0000', '0011': '0000', '0100': '0001', '0101': '0100', '0110': '0001', '0111': '0001', '1000': '0010', '1001': '1000', '1010': '0100', '1011': '0010', '1100': '0011', '1101': '1100', '1110': '0101', '1111': '0100'},


    # 4 bit divider
    # A/B
    # 0 division depends on architecture ¯\_(ツ)_/¯
    # A3,A2,A1,A0,B3,B2,B1,B0|Q3,Q2,Q1,Q0
    "divider_4b" : {'00000000': '0000', '00000001': '0000', '00000010': '0000', '00000011': '0000', '00000100': '0000', '00000101': '0000', '00000110': '0000', '00000111': '0000', '00001000': '0000', '00001001': '0000', '00001010': '0000', '00001011': '0000', '00001100': '0000', '00001101': '0000', '00001110': '0000', '00001111': '0000', '00010000': '0000', '00010001': '0001', '00010010': '0000', '00010011': '0000', '00010100': '0000', '00010101': '0000', '00010110': '0000', '00010111': '0000', '00011000': '0000', '00011001': '0000', '00011010': '0000', '00011011': '0000', '00011100': '0000', '00011101': '0000', '00011110': '0000', '00011111': '0000', '00100000': '0000', '00100001': '0010', '00100010': '0001', '00100011': '0000', '00100100': '0000', '00100101': '0000', '00100110': '0000', '00100111': '0000', '00101000': '0000', '00101001': '0000', '00101010': '0000', '00101011': '0000', '00101100': '0000', '00101101': '0000', '00101110': '0000', '00101111': '0000', '00110000': '0000', '00110001': '0011', '00110010': '0001', '00110011': '0001', '00110100': '0000', '00110101': '0000', '00110110': '0000', '00110111': '0000', '00111000': '0000', '00111001': '0000', '00111010': '0000', '00111011': '0000', '00111100': '0000', '00111101': '0000', '00111110': '0000', '00111111': '0000', '01000000': '0000', '01000001': '0100', '01000010': '0010', '01000011': '0001', '01000100': '0001', '01000101': '0000', '01000110': '0000', '01000111': '0000', '01001000': '0000', '01001001': '0000', '01001010': '0000', '01001011': '0000', '01001100': '0000', '01001101': '0000', '01001110': '0000', '01001111': '0000', '01010000': '0000', '01010001': '0101', '01010010': '0010', '01010011': '0001', '01010100': '0001', '01010101': '0001', '01010110': '0000', '01010111': '0000', '01011000': '0000', '01011001': '0000', '01011010': '0000', '01011011': '0000', '01011100': '0000', '01011101': '0000', '01011110': '0000', '01011111': '0000', '01100000': '0000', '01100001': '0110', '01100010': '0011', '01100011': '0010', '01100100': '0001', '01100101': '0001', '01100110': '0001', '01100111': '0000', '01101000': '0000', '01101001': '0000', '01101010': '0000', '01101011': '0000', '01101100': '0000', '01101101': '0000', '01101110': '0000', '01101111': '0000', '01110000': '0000', '01110001': '0111', '01110010': '0011', '01110011': '0010', '01110100': '0001', '01110101': '0001', '01110110': '0001', '01110111': '0001', '01111000': '0000', '01111001': '0000', '01111010': '0000', '01111011': '0000', '01111100': '0000', '01111101': '0000', '01111110': '0000', '01111111': '0000', '10000000': '0000', '10000001': '1000', '10000010': '0100', '10000011': '0010', '10000100': '0010', '10000101': '0001', '10000110': '0001', '10000111': '0001', '10001000': '0001', '10001001': '0000', '10001010': '0000', '10001011': '0000', '10001100': '0000', '10001101': '0000', '10001110': '0000', '10001111': '0000', '10010000': '0000', '10010001': '1001', '10010010': '0100', '10010011': '0011', '10010100': '0010', '10010101': '0001', '10010110': '0001', '10010111': '0001', '10011000': '0001', '10011001': '0001', '10011010': '0000', '10011011': '0000', '10011100': '0000', '10011101': '0000', '10011110': '0000', '10011111': '0000', '10100000': '0000', '10100001': '1010', '10100010': '0101', '10100011': '0011', '10100100': '0010', '10100101': '0010', '10100110': '0001', '10100111': '0001', '10101000': '0001', '10101001': '0001', '10101010': '0001', '10101011': '0000', '10101100': '0000', '10101101': '0000', '10101110': '0000', '10101111': '0000', '10110000': '0000', '10110001': '1011', '10110010': '0101', '10110011': '0011', '10110100': '0010', '10110101': '0010', '10110110': '0001', '10110111': '0001', '10111000': '0001', '10111001': '0001', '10111010': '0001', '10111011': '0001', '10111100': '0000', '10111101': '0000', '10111110': '0000', '10111111': '0000', '11000000': '0000', '11000001': '1100', '11000010': '0110', '11000011': '0100', '11000100': '0011', '11000101': '0010', '11000110': '0010', '11000111': '0001', '11001000': '0001', '11001001': '0001', '11001010': '0001', '11001011': '0001', '11001100': '0001', '11001101': '0000', '11001110': '0000', '11001111': '0000', '11010000': '0000', '11010001': '1101', '11010010': '0110', '11010011': '0100', '11010100': '0011', '11010101': '0010', '11010110': '0010', '11010111': '0001', '11011000': '0001', '11011001': '0001', '11011010': '0001', '11011011': '0001', '11011100': '0001', '11011101': '0001', '11011110': '0000', '11011111': '0000', '11100000': '0000', '11100001': '1110', '11100010': '0111', '11100011': '0100', '11100100': '0011', '11100101': '0010', '11100110': '0010', '11100111': '0010', '11101000': '0001', '11101001': '0001', '11101010': '0001', '11101011': '0001', '11101100': '0001', '11101101': '0001', '11101110': '0001', '11101111': '0000', '11110000': '0000', '11110001': '1111', '11110010': '0111', '11110011': '0101', '11110100': '0011', '11110101': '0011', '11110110': '0010', '11110111': '0010', '11111000': '0001', '11111001': '0001', '11111010': '0001', '11111011': '0001', '11111100': '0001', '11111101': '0001', '11111110': '0001', '11111111': '0001'},

    # 4 bit divider with remainder
    # A/B
    # 0 division depends on architecture ¯\_(ツ)_/¯
    # A3,A2,A1,A0,B3,B2,B1,B0|Q3,Q2,Q1,Q0,R3,R2,R1,R0
    "divider_with_remainder_4b" : {'00000000': '00000000', '00000001': '00000000', '00000010': '00000000', '00000011': '00000000', '00000100': '00000000', '00000101': '00000000', '00000110': '00000000', '00000111': '00000000', '00001000': '00000000', '00001001': '00000000', '00001010': '00000000', '00001011': '00000000', '00001100': '00000000', '00001101': '00000000', '00001110': '00000000', '00001111': '00000000', '00010000': '00000001', '00010001': '00010000', '00010010': '00000001', '00010011': '00000001', '00010100': '00000001', '00010101': '00000001', '00010110': '00000001', '00010111': '00000001', '00011000': '00000001', '00011001': '00000001', '00011010': '00000001', '00011011': '00000001', '00011100': '00000001', '00011101': '00000001', '00011110': '00000001', '00011111': '00000001', '00100000': '00000010', '00100001': '00100000', '00100010': '00010000', '00100011': '00000010', '00100100': '00000010', '00100101': '00000010', '00100110': '00000010', '00100111': '00000010', '00101000': '00000010', '00101001': '00000010', '00101010': '00000010', '00101011': '00000010', '00101100': '00000010', '00101101': '00000010', '00101110': '00000010', '00101111': '00000010', '00110000': '00000011', '00110001': '00110000', '00110010': '00010001', '00110011': '00010000', '00110100': '00000011', '00110101': '00000011', '00110110': '00000011', '00110111': '00000011', '00111000': '00000011', '00111001': '00000011', '00111010': '00000011', '00111011': '00000011', '00111100': '00000011', '00111101': '00000011', '00111110': '00000011', '00111111': '00000011', '01000000': '00000100', '01000001': '01000000', '01000010': '00100000', '01000011': '00010001', '01000100': '00010000', '01000101': '00000100', '01000110': '00000100', '01000111': '00000100', '01001000': '00000100', '01001001': '00000100', '01001010': '00000100', '01001011': '00000100', '01001100': '00000100', '01001101': '00000100', '01001110': '00000100', '01001111': '00000100', '01010000': '00000101', '01010001': '01010000', '01010010': '00100001', '01010011': '00010010', '01010100': '00010001', '01010101': '00010000', '01010110': '00000101', '01010111': '00000101', '01011000': '00000101', '01011001': '00000101', '01011010': '00000101', '01011011': '00000101', '01011100': '00000101', '01011101': '00000101', '01011110': '00000101', '01011111': '00000101', '01100000': '00000110', '01100001': '01100000', '01100010': '00110000', '01100011': '00100000', '01100100': '00010010', '01100101': '00010001', '01100110': '00010000', '01100111': '00000110', '01101000': '00000110', '01101001': '00000110', '01101010': '00000110', '01101011': '00000110', '01101100': '00000110', '01101101': '00000110', '01101110': '00000110', '01101111': '00000110', '01110000': '00000111', '01110001': '01110000', '01110010': '00110001', '01110011': '00100001', '01110100': '00010011', '01110101': '00010010', '01110110': '00010001', '01110111': '00010000', '01111000': '00000111', '01111001': '00000111', '01111010': '00000111', '01111011': '00000111', '01111100': '00000111', '01111101': '00000111', '01111110': '00000111', '01111111': '00000111', '10000000': '00001000', '10000001': '10000000', '10000010': '01000000', '10000011': '00100010', '10000100': '00100000', '10000101': '00010011', '10000110': '00010010', '10000111': '00010001', '10001000': '00010000', '10001001': '00001000', '10001010': '00001000', '10001011': '00001000', '10001100': '00001000', '10001101': '00001000', '10001110': '00001000', '10001111': '00001000', '10010000': '00001001', '10010001': '10010000', '10010010': '01000001', '10010011': '00110000', '10010100': '00100001', '10010101': '00010100', '10010110': '00010011', '10010111': '00010010', '10011000': '00010001', '10011001': '00010000', '10011010': '00001001', '10011011': '00001001', '10011100': '00001001', '10011101': '00001001', '10011110': '00001001', '10011111': '00001001', '10100000': '00001010', '10100001': '10100000', '10100010': '01010000', '10100011': '00110001', '10100100': '00100010', '10100101': '00100000', '10100110': '00010100', '10100111': '00010011', '10101000': '00010010', '10101001': '00010001', '10101010': '00010000', '10101011': '00001010', '10101100': '00001010', '10101101': '00001010', '10101110': '00001010', '10101111': '00001010', '10110000': '00001011', '10110001': '10110000', '10110010': '01010001', '10110011': '00110010', '10110100': '00100011', '10110101': '00100001', '10110110': '00010101', '10110111': '00010100', '10111000': '00010011', '10111001': '00010010', '10111010': '00010001', '10111011': '00010000', '10111100': '00001011', '10111101': '00001011', '10111110': '00001011', '10111111': '00001011', '11000000': '00001100', '11000001': '11000000', '11000010': '01100000', '11000011': '01000000', '11000100': '00110000', '11000101': '00100010', '11000110': '00100000', '11000111': '00010101', '11001000': '00010100', '11001001': '00010011', '11001010': '00010010', '11001011': '00010001', '11001100': '00010000', '11001101': '00001100', '11001110': '00001100', '11001111': '00001100', '11010000': '00001101', '11010001': '11010000', '11010010': '01100001', '11010011': '01000001', '11010100': '00110001', '11010101': '00100011', '11010110': '00100001', '11010111': '00010110', '11011000': '00010101', '11011001': '00010100', '11011010': '00010011', '11011011': '00010010', '11011100': '00010001', '11011101': '00010000', '11011110': '00001101', '11011111': '00001101', '11100000': '00001110', '11100001': '11100000', '11100010': '01110000', '11100011': '01000010', '11100100': '00110010', '11100101': '00100100', '11100110': '00100010', '11100111': '00100000', '11101000': '00010110', '11101001': '00010101', '11101010': '00010100', '11101011': '00010011', '11101100': '00010010', '11101101': '00010001', '11101110': '00010000', '11101111': '00001110', '11110000': '00001111', '11110001': '11110000', '11110010': '01110001', '11110011': '01010000', '11110100': '00110011', '11110101': '00110000', '11110110': '00100011', '11110111': '00100001', '11111000': '00010111', '11111001': '00010110', '11111010': '00010101', '11111011': '00010100', '11111100': '00010011', '11111101': '00010010', '11111110': '00010001', '11111111': '00010000'},

    ####### Multipliers #######
    # 2 bit multiplier
    # A1,A0,B1,B0|P3,P2,P1,P0
    "multiplier_2b" : {
        "0000" : "0000", 
        "0001" : "0000",
        "0010" : "0000",
        "0011" : "0000",
        "0100" : "0000",
        "0101" : "0001",
        "0110" : "0010",
        "0111" : "0011",
        "1000" : "0000",
        "1001" : "0010",
        "1010" : "0100",
        "1011" : "0110",
        "1100" : "0000",
        "1101" : "0011",
        "1110" : "0110",
        "1111" : "1001"
    },

    # 4 bit multiplier
    # A3,A2,A1,A0,B3,B2,B1,B0|P7,P6,P5,P4,P3,P2,P1,P0
    "multiplier_4b": {
        '00000000': '00000000', 
        '00000001': '00000000', 
        '00000010': '00000000', 
        '00000011': '00000000', 
        '00000100': '00000000', 
        '00000101': '00000000', 
        '00000110': '00000000', 
        '00000111': '00000000', 
        '00001000': '00000000', 
        '00001001': '00000000', 
        '00001010': '00000000', 
        '00001011': '00000000', 
        '00001100': '00000000', 
        '00001101': '00000000', 
        '00001110': '00000000', 
        '00001111': '00000000', 
        '00010000': '00000000', 
        '00010001': '00000001', 
        '00010010': '00000010', 
        '00010011': '00000011', 
        '00010100': '00000100', 
        '00010101': '00000101', 
        '00010110': '00000110', 
        '00010111': '00000111', 
        '00011000': '00001000', 
        '00011001': '00001001', 
        '00011010': '00001010', 
        '00011011': '00001011', 
        '00011100': '00001100', 
        '00011101': '00001101', 
        '00011110': '00001110', 
        '00011111': '00001111', 
        '00100000': '00000000', 
        '00100001': '00000010', 
        '00100010': '00000100', 
        '00100011': '00000110', 
        '00100100': '00001000', 
        '00100101': '00001010', 
        '00100110': '00001100', 
        '00100111': '00001110', 
        '00101000': '00010000', 
        '00101001': '00010010', 
        '00101010': '00010100', 
        '00101011': '00010110', 
        '00101100': '00011000', 
        '00101101': '00011010', 
        '00101110': '00011100', 
        '00101111': '00011110', 
        '00110000': '00000000', 
        '00110001': '00000011', 
        '00110010': '00000110', 
        '00110011': '00001001', 
        '00110100': '00001100', 
        '00110101': '00001111', 
        '00110110': '00010010', 
        '00110111': '00010101', 
        '00111000': '00011000', 
        '00111001': '00011011', 
        '00111010': '00011110', 
        '00111011': '00100001', 
        '00111100': '00100100', 
        '00111101': '00100111', 
        '00111110': '00101010', 
        '00111111': '00101101', 
        '01000000': '00000000', 
        '01000001': '00000100', 
        '01000010': '00001000', 
        '01000011': '00001100', 
        '01000100': '00010000', 
        '01000101': '00010100', 
        '01000110': '00011000', 
        '01000111': '00011100', 
        '01001000': '00100000', 
        '01001001': '00100100', 
        '01001010': '00101000', 
        '01001011': '00101100', 
        '01001100': '00110000', 
        '01001101': '00110100', 
        '01001110': '00111000', 
        '01001111': '00111100', 
        '01010000': '00000000', 
        '01010001': '00000101', 
        '01010010': '00001010', 
        '01010011': '00001111', 
        '01010100': '00010100', 
        '01010101': '00011001', 
        '01010110': '00011110', 
        '01010111': '00100011', 
        '01011000': '00101000', 
        '01011001': '00101101', 
        '01011010': '00110010', 
        '01011011': '00110111', 
        '01011100': '00111100', 
        '01011101': '01000001', 
        '01011110': '01000110', 
        '01011111': '01001011', 
        '01100000': '00000000', 
        '01100001': '00000110', 
        '01100010': '00001100', 
        '01100011': '00010010', 
        '01100100': '00011000', 
        '01100101': '00011110', 
        '01100110': '00100100', 
        '01100111': '00101010', 
        '01101000': '00110000', 
        '01101001': '00110110', 
        '01101010': '00111100', 
        '01101011': '01000010', 
        '01101100': '01001000', 
        '01101101': '01001110', 
        '01101110': '01010100', 
        '01101111': '01011010', 
        '01110000': '00000000', 
        '01110001': '00000111', 
        '01110010': '00001110', 
        '01110011': '00010101', 
        '01110100': '00011100', 
        '01110101': '00100011', 
        '01110110': '00101010', 
        '01110111': '00110001', 
        '01111000': '00111000', 
        '01111001': '00111111', 
        '01111010': '01000110', 
        '01111011': '01001101', 
        '01111100': '01010100', 
        '01111101': '01011011', 
        '01111110': '01100010', 
        '01111111': '01101001', 
        '10000000': '00000000', 
        '10000001': '00001000', 
        '10000010': '00010000', 
        '10000011': '00011000', 
        '10000100': '00100000', 
        '10000101': '00101000', 
        '10000110': '00110000', 
        '10000111': '00111000', 
        '10001000': '01000000', 
        '10001001': '01001000', 
        '10001010': '01010000', 
        '10001011': '01011000', 
        '10001100': '01100000', 
        '10001101': '01101000', 
        '10001110': '01110000', 
        '10001111': '01111000', 
        '10010000': '00000000', 
        '10010001': '00001001', 
        '10010010': '00010010', 
        '10010011': '00011011', 
        '10010100': '00100100', 
        '10010101': '00101101', 
        '10010110': '00110110', 
        '10010111': '00111111', 
        '10011000': '01001000', 
        '10011001': '01010001', 
        '10011010': '01011010', 
        '10011011': '01100011', 
        '10011100': '01101100', 
        '10011101': '01110101', 
        '10011110': '01111110', 
        '10011111': '10000111', 
        '10100000': '00000000', 
        '10100001': '00001010', 
        '10100010': '00010100', 
        '10100011': '00011110', 
        '10100100': '00101000', 
        '10100101': '00110010', 
        '10100110': '00111100', 
        '10100111': '01000110', 
        '10101000': '01010000', 
        '10101001': '01011010', 
        '10101010': '01100100', 
        '10101011': '01101110', 
        '10101100': '01111000', 
        '10101101': '10000010', 
        '10101110': '10001100', 
        '10101111': '10010110', 
        '10110000': '00000000', 
        '10110001': '00001011', 
        '10110010': '00010110', 
        '10110011': '00100001', 
        '10110100': '00101100', 
        '10110101': '00110111', 
        '10110110': '01000010', 
        '10110111': '01001101', 
        '10111000': '01011000', 
        '10111001': '01100011', 
        '10111010': '01101110', 
        '10111011': '01111001', 
        '10111100': '10000100', 
        '10111101': '10001111', 
        '10111110': '10011010', 
        '10111111': '10100101', 
        '11000000': '00000000', 
        '11000001': '00001100', 
        '11000010': '00011000', 
        '11000011': '00100100', 
        '11000100': '00110000', 
        '11000101': '00111100', 
        '11000110': '01001000', 
        '11000111': '01010100', 
        '11001000': '01100000', 
        '11001001': '01101100', 
        '11001010': '01111000', 
        '11001011': '10000100', 
        '11001100': '10010000', 
        '11001101': '10011100', 
        '11001110': '10101000', 
        '11001111': '10110100', 
        '11010000': '00000000', 
        '11010001': '00001101', 
        '11010010': '00011010', 
        '11010011': '00100111', 
        '11010100': '00110100', 
        '11010101': '01000001', 
        '11010110': '01001110', 
        '11010111': '01011011', 
        '11011000': '01101000', 
        '11011001': '01110101', 
        '11011010': '10000010', 
        '11011011': '10001111', 
        '11011100': '10011100', 
        '11011101': '10101001', 
        '11011110': '10110110', 
        '11011111': '11000011', 
        '11100000': '00000000', 
        '11100001': '00001110', 
        '11100010': '00011100', 
        '11100011': '00101010', 
        '11100100': '00111000', 
        '11100101': '01000110', 
        '11100110': '01010100', 
        '11100111': '01100010', 
        '11101000': '01110000', 
        '11101001': '01111110', 
        '11101010': '10001100', 
        '11101011': '10011010', 
        '11101100': '10101000', 
        '11101101': '10110110', 
        '11101110': '11000100', 
        '11101111': '11010010', 
        '11110000': '00000000', 
        '11110001': '00001111', 
        '11110010': '00011110', 
        '11110011': '00101101', 
        '11110100': '00111100', 
        '11110101': '01001011', 
        '11110110': '01011010', 
        '11110111': '01101001', 
        '11111000': '01111000', 
        '11111001': '10000111', 
        '11111010': '10010110', 
        '11111011': '10100101', 
        '11111100': '10110100', 
        '11111101': '11000011', 
        '11111110': '11010010', 
        '11111111': '11100001'}
}



# END arithmetic_circuits.py